VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "vbRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
']pvG}t     Mario
'󪩥  G1.00      1999.05.25.
'            1.01      1999.09.07. ץŪgƦ~
'                                  NLenLenB
'
'W  GvbRegistry
'k      G
'          ReadDefaultString  ŪYw]r
'          ReadString         ŪYWr
'          WriteDefaultString gJYw]Wr
'          WriteString        gJYWr
'          DeleteString       RYWr

Option Explicit

'vbRegistryһݭnAPIƫŧi
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

Enum RootType
     HKEY_CLASSES_ROOT = &H80000000
     HKEY_CURRENT_CONFIG = &H80000005
     HKEY_CURRENT_USER = &H80000001
     HKEY_LOCAL_MACHINE = &H80000002
     HKEY_DYN_DATA = &H80000006
     HKEY_PERFORMANCE_DATA = &H80000004
     HKEY_USERS = &H80000003
End Enum

'lpType ƫO
Private Const REG_SZ = 1               'r
Private Const REG_EXPAND_SZ = 2        'ii}r
Private Const REG_BINARY = 3           'Binary
Private Const REG_DWORD = 4            '
Private Const REG_DWORD_BIG_ENDIAN = 5 'Big Endian
Private Const REG_NULTI_SZ = 7         'hr

'pܼ
Private mvarhKey As Long       'hKey
Private mvarSubKey As String   'SubKey
Private mvarKeyName As String  'KeyName
Private mvarKeyValue As String 'KeyValue

Private Function KeySeperate(vData As String) As String
   Dim KeyLenB As Long
   KeyLenB = LenB(vData)
   
   Dim SubKeyPos As Long
   
   SubKeyPos = KeyLenB
   Dim opOK As Boolean
   opOK = False
   Do While SubKeyPos > 1
      If Mid(vData, SubKeyPos, 1) = "\" Then
         mvarSubKey = Mid(vData, 1, SubKeyPos - 1)
         mvarKeyName = Mid(vData, SubKeyPos + 1, KeyLenB - SubKeyPos)
         opOK = True
         Exit Do
      Else
         SubKeyPos = SubKeyPos - 1
      End If
   Loop
   
   If opOK = False Then
      mvarSubKey = vData
      mvarKeyName = vData
   End If
   
End Function

Public Function WriteString(RootName As RootType, SubKey As String, KeyValue As String) As Boolean
  Call KeySeperate(SubKey)
  
  KeyValue = KeyValue & Chr(0)
  Dim ret As Long
  ret = RegCreateKey(RootName, mvarSubKey, mvarhKey)
  Dim wKey As String
  wKey = KeyValue & Chr(0)
  ret = RegSetValueEx(mvarhKey, mvarKeyName, ByVal 0, ByVal 1, ByVal wKey, LenB(wKey))
  
  If ret = 0 Then WriteString = True
End Function

Public Function ReadString(RootName As RootType, SubKey As String, DefaultValue As String) As String
  Call KeySeperate(SubKey)
  
  Dim ret As Long
  ret = RegOpenKey(RootName, mvarSubKey, mvarhKey)
  
  Dim StrLenB As Long
  Dim lpType As Long
  Dim ldata As String
  ret = RegQueryValueEx(mvarhKey, mvarKeyName, ByVal 0, lpType, vbNullString, StrLenB)
  ldata = String(StrLenB, Chr(0))
  ret = RegQueryValueEx(mvarhKey, mvarKeyName, ByVal 0, lpType, ByVal ldata, StrLenB + 1)
  If ret <> 0 Then
     ReadString = DefaultValue
  Else
     mvarKeyValue = ldata
     ReadString = mvarKeyValue
  End If
  
End Function


Private Sub Class_Terminate()
  Call RegCloseKey(mvarhKey)
End Sub


Public Function DeleteString(RootName As RootType, SubKey As String) As Boolean
  Call KeySeperate(SubKey)
  
  Dim ret As Long
  ret = RegOpenKey(RootName, mvarSubKey, mvarhKey)
  ret = RegDeleteValue(mvarhKey, mvarKeyName)
  
  If ret = 0 Then
     DeleteString = True
  Else
     ret = RegOpenKey(RootName, mvarSubKey, mvarhKey)
     ret = RegDeleteKey(mvarhKey, mvarKeyName)
     If ret = 0 Then
        DeleteString = True
     Else
        DeleteString = False
     End If
  End If
  
End Function


Public Function ReadDefaultString(RootName As RootType, SubKey As String, DefaultValue As String) As String

  Dim ret As Long
  Dim StrLenB As Long
  Dim KeyStr As String
  ret = RegQueryValue(RootName, SubKey, vbNullString, StrLenB)
  KeyStr = String(StrLenB, Chr(0))
  ret = RegQueryValue(RootName, SubKey, KeyStr, LenB(KeyStr))
  
  If ret = 0 Then
     ReadDefaultString = KeyStr
  Else
     ReadDefaultString = DefaultValue
  End If
  
End Function

Public Function WriteDefaultString(RootName As RootType, SubKey As String, KeyValue As String) As Boolean
  
  Dim ret As Long
  ret = RegSetValue(RootName, SubKey, ByVal 1, KeyValue, LenB(StrConv(KeyValue, vbFromUnicode)) + 1)
  If ret = 0 Then WriteDefaultString = True
  
End Function
